<script setup lang="ts">
import { useReceiptStore } from '@/Pos/stores/receipt'
import { useDate } from 'vuetify'
import { useAuthStore } from '@/views/Auth/stores/auth'
import { useUserStore } from '@/User/stores/user'
import type { Receipt } from '../types/Receipt'
import type { ReceiptItem } from '../types/ReceiptItem'
import { computed } from 'vue'
const auth = useAuthStore()

const userStore = useUserStore()
const receiptStore = useReceiptStore()
// const dialog = inject<Ref<boolean>>('receiptDialog')

const props = defineProps<{
  modelValue: boolean
  receipt: Receipt
  receiptItems: ReceiptItem[]
}>()
const emit = defineEmits<{
  'update:modelValue': [boolean]
  agree: []
}>()
const value = computed({
  get() {
    return props.modelValue
  },
  set(value) {
    emit('update:modelValue', value)
  }
})
</script>

<template>
  <v-dialog v-model:model-value="value" persistent width="500">
    <v-card>
      <v-card-title class="text-h5 text-center mt-5"> Confirm Payment </v-card-title>
      <v-card-text>
        <!-- {{ receiptStore.receipt }} -->
        <v-sheet border="md" class="pa-6 text-white mx-auto" max-width="auto" style="color: white">
          <v-container>
            <v-row no-gutters style="color: black">
              <v-col></v-col>
              <v-col cols="7">
                <v-img src="src\assets\MainLogo.png" width="50"></v-img>
              </v-col>
              <v-col cols="12">
                <div style="text-align: center; color: black">
                  D-Coffee <br />
                  คณะสหเวชศาสตร์ มหาวิทยาลัยบูรพา <br />
                  ประเทศไทย จ.ชลบุรี 20130<br />
                  โทร 095 332 5290
                </div>
                <br />
              </v-col>
              <!-- <v-col cols="6">
                <p>TAX ID : {{ receiptStore.receipt.id }}</p>
              </v-col> -->
              <!-- <v-col cols="4">
                <p>Queue : {{ receiptStore.queue }}</p>
              </v-col> -->
              <v-col cols="6">
                <p>DATE : {{ useDate().format(receiptStore.receipt?.createdDate, 'shortDate') }}</p>
              </v-col>
              <v-col cols="4">
                <p>
                  TIME :
                  {{
                    receiptStore.receipt?.createdDate.toLocaleTimeString('th-TH', { hour12: false })
                  }}
                </p>
              </v-col>
              <v-col cols="12">
                <p>ผู้ออกใบเสร็จ : {{ userStore.currentUser?.fullName }}</p>
              </v-col>
              <v-col cols="12"> --------------------------------------------- </v-col>
              <!-- <v-col>
                <p>รายการ</p>
              </v-col>
              <v-col>
                <p>จำนวน</p>
              </v-col>
              <v-col>
                <p>ราคา (บาท)</p>
              </v-col> -->
              <v-col>
                <v-table>
                  <thead>
                    <tr>
                      <th>รายการ</th>
                      <th>จำนวน</th>
                      <th>ราคา (บาท)</th>
                    </tr>
                  </thead>
                  <tbody>
                    <tr v-for="item of receiptStore.receiptItems" :key="item.id">
                      <td>{{ item.name }}</td>
                      <td>{{ item.unit }}</td>
                      <td>{{ item.price * item.unit }}</td>
                    </tr>
                  </tbody>
                </v-table>
              </v-col>
              <v-col cols="8">
                <p>รวม {{ receiptStore.receipt?.amount }} รายการ</p>
              </v-col>
              <v-col cols="4">
                <P>{{ receiptStore.receipt?.total }} บาท</P>
              </v-col>
              <v-col cols="12"> --------------------------------------------- </v-col>
              <!-- <v-col cols="12">
                <p v-if="receiptStore.receipt.promotion">โปรโมชัน : {{ receiptStore.receipt.promotion?.name }}</p>
                <p>โปรโมชัน : {{ promotionStore.currentPromotion?.name }}</p>

              </v-col> -->
              <!-- <v-col cols="12">
                <p v-if="receiptStore.receipt.promotion">ส่วนลด : {{ receiptStore.receipt.discount }} บาท</p>
              </v-col> -->
              <v-col cols="12">
                <p>จำนวนเงินรวมทั้งสิ้น : {{ receiptStore.receipt?.total }} บาท</p>
              </v-col>
              <v-col cols="12"> --------------------------------------------- </v-col>
              <v-col cols="6">
                <p>วิธีการชำระเงิน : {{ receiptStore.receipt?.paymentType }}</p>
              </v-col>
              <v-col cols="4">
                <p>จำนวนเงิน : {{ receiptStore.receipt?.total }}</p>
              </v-col>
              <v-col cols="6"></v-col>
              <v-col cols="4">
                <p>เงินทอน : {{ receiptStore.receipt?.change }}</p>
              </v-col>
              <v-col cols="12"> --------------------------------------------- </v-col>
              <v-col v-if="receiptStore.receipt?.member">
                <p>สมาชิก : {{ receiptStore.receipt.member?.name }}</p>
                <!-- <p>คุณได้รับ Point : {{ receiptStore.receipt.givePoint }}</p>
                <p>Point สะสม : {{ receiptStore.receipt.totalPoint }}</p> -->
              </v-col>
              <v-col cols="12"> --------------------------------------------- </v-col>
              <v-col class="center">
                <p style="text-align: center">Thank you for shopping with us.</p>
              </v-col>
            </v-row>
          </v-container>
        </v-sheet>
      </v-card-text>
      <v-card-actions>
        <v-spacer></v-spacer>
        <v-btn color="red-darken-1" variant="text" @click="(value = false), receiptStore.clear()">
          <p class="font-weight-bold">close</p>
        </v-btn>
        <v-btn
          color="green-darken-1"
          variant="text"
          @click="
            () => {
              //   receiptStore.addReceiptItem()
              value = false
              console.log(receipt)
              console.log(receiptItems)
              emit('agree'), (receiptStore.receiptDialog = false), receiptStore.clear()
            }
          "
        >
          <p class="font-weight-bold">save</p>
        </v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>
